int cfdval, bval, ncfd = 0, maxcfd = 0, mincfd = 0;
float atval, zXdel, tnloops, ncfa = 0.0, maxcfa = 0, mincfa = 0;
char *treename = "t1", *treetitle = "OptMatrix"; /*Tree Names*/
char *cfa1 = "cfa", *cfd1 = "cfd", *nbin1 = "nbin", *tr1 = "tr"; /*Tree Variables*/
char *cfa2 = "cfa/F", *cfd2 = "cfd/F", *nbin2 = "nbin/F", *tr2 = "tr/F"; /*Tree Variables*/
float cfd, cfa, nbin, tr; /*Tree Variables*/
void OptimizeTR(int cfdmin = tpdp, int cfdmax = 100*tpdp, int cfdinc = 10 /*ns*/,float atmin = 0.1, float atmax = 0.9, float atinc = 0.1, int bmin = 1, int bmax = 2500, int binc = 500, float zXoff = 0.0)
{
gROOT->ProcessLine("TStopwatch progsw1;");
gROOT->ProcessLine("progsw1.Start();");
gROOT->ProcessLine("TTree t1(treename,treetitle);"); /*Create Tree and its branches*/
gROOT->ProcessLine("t1.Branch(cfa1,&cfa,cfa2);"); /**/
gROOT->ProcessLine("t1.Branch(cfd1,&cfd,cfd2);"); /**/
gROOT->ProcessLine("t1.Branch(nbin1,&nbin,nbin2);"); /**/
gROOT->ProcessLine("t1.Branch(tr1,&tr,tr2);"); /**/
mincfd = cfdmin;
maxcfd = cfdmax;
mincfa = atmin;
maxcfa = atmax;
ncfd = (cfdmax - cfdmin) / cfdinc;
ncfa = (atmax - atmin) / atinc;
int lnum = 1;
zXdel = zXoff;
cfdval = cfdmin;
int ncfdloops = 1 + ncfd, nbloops = 1 + (bmax - bmin) / binc;
float natloops = 1 + ncfa;
tnloops = ncfdloops * natloops * nbloops;
float fperr = atinc / 10;
Ocfdval = new float[tnloops];
Oatval = new float[tnloops];
Obval = new float[tnloops];
OTimRes = new float[tnloops];
ofstream optval;
optval.open("optimumvalues.txt");
optval << "Cf Delay Value; Cf Atten Value; Number of Bins, Time Resolution" << endl;
while (cfdval <= cfdmax)
   {
   atval = atmin;
   while (atval <= (atmax + fperr))
      {
      bval = bmin;
      while (bval <= bmax)
         {
         gROOT->ProcessLine("OcfDiscrimination(cfdval,atval)");
         gROOT->ProcessLine("OzXing(zXdel)");
         gROOT->ProcessLine(".x OCreate1DHist.C(bval)");
         Ocfdval[lnum - 1] = cfdval;
         Oatval[lnum - 1] = atval;
         Obval[lnum - 1] = bval;
         OTimRes[lnum - 1] = TimRes;
         cfd = cfdval; //Set variables to be written to Tree
         cfa = atval;
         tr = TimRes;
         nbin = bval;
         gROOT->ProcessLine("t1.Fill();"); /*Write the values to Tree*/
         cout << "\rLoop Number " << lnum << " out of " << tnloops <<". Values: " << cfdval << ", " << atval << ", " << bval << ", " << nbThres << ", " << TNHcounts << ", " << hmaxc << ", " << NCinWidth << ", " << TimRes;
         optval << cfdval << ";" << atval << ";" << bval << ";" << nbThres << ";" << TNHcounts << ";" << hmaxc << ";" << NCinWidth << ";" << TimRes <<endl;
         fflush(stdout);
         bval = bval + binc;
         lnum++;
         }
      atval = atval + atinc;
      }
   cfdval = cfdval + cfdinc;
   }
cout <<endl;
float OTRmin = 99999, OTRmax = 0;
int OTRnmin = 0, OTRnmax = 0;
lnum = 0;
while ( lnum < tnloops)
   {
   if (OTimRes[lnum] > OTRmax)
      {
      OTRmax = OTimRes[lnum];
      OTRnmax = lnum;
      }
   if (OTimRes[lnum] < OTRmin)
      {
      OTRmin = OTimRes[lnum];
      OTRnmin = lnum;
      }
   lnum++;
   }
gROOT->ProcessLine("progsw1.Stop();");
gROOT->ProcessLine("progsw1.RealTime()");
cout << "The Optimum Time Resolution was found to be " << OTRmin << " ns." <<endl;
cout << "The Optimum time resolution was obtained when the CF delay was " << Ocfdval[OTRnmin] << ", the CF attenuation factor was " << Oatval[OTRnmin] << ", and the number of histogram bins was " << Obval[OTRnmin] << "." <<endl;
cout << "The Maximum Time Resolution was found to be " << OTRmax << " ns." <<endl;
cout << "The Maximum time resolution was obtained when the CF delay was " << Ocfdval[OTRnmax] << ", the CF attenuation factor was " << Oatval[OTRnmax] << ", and the number of histogram bins was " << Obval[OTRnmax] << "." <<endl;
gROOT->ProcessLine("progsw1.ResetRealTime();");
}
